Index: lib/TWiki/UI/View.pm
===================================================================
--- lib/TWiki/UI/View.pm	(revision 1767)
+++ lib/TWiki/UI/View.pm	(working copy)
@@ -29,7 +29,9 @@
 
 use strict;
 use TWiki;
+use TWiki::User;
 use TWiki::UI;
+use TWiki::Templates;
 
 =pod
 
@@ -45,274 +47,274 @@
 =cut
 
 sub view {
-  my ( $webName, $topic, $userName, $query ) = @_;
+    my ( $webName, $topic, $userName, $query ) = @_;
 
-  my $rev = $query->param( "rev" );
-  my $viewRaw = $query->param( "raw" ) || "";
-  my $unlock  = $query->param( "unlock" ) || "";
-  my $skin    = $query->param( "skin" );
-  my $contentType = $query->param( "contenttype" );
+    my $rev = $query->param( "rev" );
+    my $viewRaw = $query->param( "raw" ) || "";
+    my $unlock  = $query->param( "unlock" ) || "";
+    my $contentType = $query->param( "contenttype" );
 
-  TWiki::UI::writeDebugTimes( "view - initialized" );
+    my $text = "";
+    my $meta = "";
+    my $maxrev = 1;
+    my $extra = "";
+    my $wikiUserName = TWiki::User::userToWikiName( $userName );
+    my $revdate = "";
+    my $revuser = "";
 
-  my $tmpl = "";
-  my $text = "";
-  my $meta = "";
-  my $maxrev = 1;
-  my $extra = "";
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
-  my $revdate = "";
-  my $revuser = "";
+    return unless TWiki::UI::webExists( $webName, $topic );
 
-  $skin = &TWiki::Prefs::getPreferencesValue( "SKIN" ) unless ( $skin );
+    my $skin = TWiki::getSkin();
 
-  # Set page generation mode to RSS if using an RSS skin
-  if( $skin =~ /^rss/ ) {
-    TWiki::setPageMode( 'rss' );
-  }
+    # Set page generation mode to RSS if using an RSS skin
+    if( $skin =~ /^rss/ ) {
+        TWiki::Render::setRenderMode( 'rss' );
+    }
 
-  # get view template, standard view or a view with a different skin
-  $tmpl = &TWiki::Store::readTemplate( "view", $skin );
-  if( ! $tmpl ) {
-    TWiki::writeHeader( $query );
-    print "<html><body>\n"
-      . "<h1>TWiki Installation Error</h1>\n"
-        . "Template file view.tmpl not found or template directory \n"
-          . "$TWiki::templateDir not found.<p />\n"
-            . "Check the \$templateDir variable in TWiki.cfg.\n"
-              . "</body></html>\n";
-    return;
-  }
-  TWiki::UI::writeDebugTimes( "view - readTemplate" );
+    if( $unlock eq "on" ) {
+        # unlock topic, user cancelled out of edit
+        TWiki::Store::lockTopic( $webName, $topic, "on" );
+    }
 
-  return unless TWiki::UI::webExists( $webName, $topic );
-  TWiki::UI::writeDebugTimes( "view - webExists" );
+    my $topicExists = TWiki::Store::topicExists( $webName, $topic );
+    if( $topicExists ) {
+        ( $meta, $text ) = TWiki::Store::readTopic( $webName, $topic );
+        ( $revdate, $revuser, $maxrev ) =
+          $meta->getRevisionInfo( $webName, $topic );
 
-  if( $unlock eq "on" ) {
-    # unlock topic, user cancelled out of edit
-    &TWiki::Store::lockTopic( $topic, "on" );
-  }
+        $revdate = TWiki::formatTime( $revdate );
 
-  # Most recent topic read in even if earlier topic requested - makes
-  # code simpler and performance impact should be minimal
-  my $topicExists = &TWiki::Store::topicExists( $webName, $topic );
-  if( $topicExists ) {
-    if( $viewRaw ) {
-      $text = &TWiki::Store::readTopicRaw( $webName, $topic );
-    } else {
-      ( $meta, $text ) = &TWiki::Store::readTopic( $webName, $topic );
+        if( $rev ) {
+            $rev =~ s/r?1\.//go;  # cut 'r' and major
+            $rev = 1 if( $rev < 1 );
+            $rev = $maxrev if( $rev > $maxrev );
+        } else {
+            $rev = $maxrev;
+        }
+
+        if( $rev < $maxrev ) {
+            # Most recent topic read in even if earlier topic requested - makes
+            # code simpler and performance impact should be minimal
+            ( $meta, $text ) =
+              TWiki::Store::readTopicVersion( $webName, $topic, "1.$rev" );
+
+            ( $revdate, $revuser ) =
+              TWiki::Store::getRevisionInfo( $webName, $topic, "1.$rev");
+            $revdate = TWiki::formatTime( $revdate );
+            $extra .= "r1.$rev";
+        }
+    } else { # Topic does not exist yet
+        $rev = 1;
+        if( TWiki::isValidTopicName( $topic )) {
+            ( $meta, $text ) =
+              TWiki::UI::readTemplateTopic( "WebTopicViewTemplate" );
+        } else {
+            ( $meta, $text ) =
+              TWiki::UI::readTemplateTopic( "WebTopicNonWikiTemplate" );
+        }
+        $extra .= " (not exist)";
     }
-    ( $revdate, $revuser, $maxrev ) = &TWiki::Store::getRevisionInfoFromMeta( $webName, $topic, $meta);
-    $revdate = TWiki::formatTime( $revdate );
 
-    if( $rev ) {
-      $rev =~ s/r?1\.//go;  # cut 'r' and major
-      if( $rev < 1 )       { $rev = 1; }
-      if( $rev > $maxrev ) { $rev = $maxrev; }
+    if( $viewRaw ) {
+        $extra .= " raw=$viewRaw";
+        if( $viewRaw =~ /debug/i ) {
+            $text = TWiki::Store::getDebugText( $meta, $text );
+        }
+        # a skin name starting with the word 'text' is intended to be
+        # used like this:
+        # http://.../view/Codev/MyTopic?skin=text&contenttype=text/plain&raw=on
+        # which shows the topic as plain text; useful for those who want
+        # to download plain text for the topic.
+        # SMELL: this is not documented anywhere that I can find, and the
+        # poor slob who creates "texture_skin" is going to get a hell of
+        # a shock! This should be done with "raw=text", not with a skin.
+        if( $skin !~ /^text/ ) {
+            my $vtext = "<form><textarea readonly=\"readonly\" " .
+              "wrap=\"virtual\" rows=\"\%EDITBOXHEIGHT%\" " .
+                "cols=\"\%EDITBOXWIDTH%\">";
+            $vtext = TWiki::handleCommonTags( $vtext, $topic );
+            $text = TWiki::entityEncode( $text );
+            $text =~ s/\t/   /go;
+            $text = "$vtext$text</textarea></form>";
+        }
     } else {
-      $rev = $maxrev;
+        $text = TWiki::handleCommonTags( $text, $topic );
+        $text = TWiki::Render::getRenderedVersion( $text );
     }
 
-    if( $rev < $maxrev ) {
-      if( $viewRaw ) {
-        $text = &TWiki::Store::readTopicRaw( $webName, $topic, "1.$rev" );
-      } else {
-        ( $meta, $text ) = &TWiki::Store::readTopicVersion( $webName, $topic, "1.$rev" );
-      }
-      ( $revdate, $revuser ) = &TWiki::Store::getRevisionInfo( $webName, $topic, "1.$rev");
-      $revdate = TWiki::formatTime( $revdate );
-      $extra .= "r1.$rev";
+    if( $TWiki::doLogTopicView ) {
+        # write log entry
+        TWiki::writeLog( "view", "$webName.$topic", $extra );
     }
-  } else {
-    $rev = 1;
-    if( &TWiki::isWikiName( $topic ) || &TWiki::isAbbrev( $topic ) ) {
-      ( $meta, $text ) = &TWiki::Store::readTemplateTopic( "WebTopicViewTemplate" );
-    } else {
-      ( $meta, $text ) = &TWiki::Store::readTemplateTopic( "WebTopicNonWikiTemplate" );
-    }
-    $extra .= " (not exist)";
-  }
 
-  if( $viewRaw ) {
-    $extra .= " raw=$viewRaw";
-    if( $viewRaw !~ /debug/i ) {
-      $text = join( "\n", grep{ !/^%META:([^{]+){(.*)}%$/ } split( /\r?\n/, $text ) );
+    # get view template, standard view or a view with a different skin
+    my $tmpl = TWiki::Templates::readTemplate( "view", $skin );
+    if( ! $tmpl ) {
+        my $mess = "<html><body>\n"
+          . "<h1>TWiki Installation Error</h1>\n"
+            . "Template file view.tmpl not found or template directory \n"
+              . "$TWiki::templateDir not found.<p />\n"
+                . "Check the \$templateDir variable in TWiki.cfg.\n"
+                  . "</body></html>\n";
+        TWiki::writeHeader( $query, length( $mess ));
+        print $mess;
+        return;
     }
-    if( $skin !~ /^text/ ) {
-      my $vtext = "<form><textarea readonly=\"readonly\" wrap=\"virtual\" rows=\"%EDITBOXHEIGHT%\" cols=\"%EDITBOXWIDTH%\">";
-      $vtext = &TWiki::handleCommonTags( $vtext, $topic );
-      $text =~ s/&/&amp\;/go;
-      $text =~ s/%/&\#037\;/go;
-      $text =~ s/</&lt\;/go;
-      $text =~ s/>/&gt\;/go;
-      $text =~ s/\t/   /go;
-      $text = "$vtext$text</textarea></form>";
-    }
-  }
 
-  TWiki::UI::writeDebugTimes( "view - get rev info" );
+    my( $mirrorSiteName, $mirrorViewURL, $mirrorLink, $mirrorNote ) =
+      TWiki::readOnlyMirrorWeb( $webName );
 
-  if( ! $viewRaw ) {
-    $text = &TWiki::handleCommonTags( $text, $topic );
-    TWiki::UI::writeDebugTimes( "view - handleCommonTags done" );
-    $text = &TWiki::Render::getRenderedVersion( $text );
-    TWiki::UI::writeDebugTimes( "view - getRendereredVersion done" );
-  }
+    if( $mirrorSiteName ) {
+        # disable edit and attach
+        # FIXME: won't work with non-default skins, see %EDITURL%
+        $tmpl =~ s/%EDITTOPIC%/$mirrorLink | <strike>Edit<\/strike>/go;
+        $tmpl =~ s/<a [^>]*?>Attach<\/a>/<strike>Attach<\/strike>/goi;
+        if( $topicExists ) {
+            # remove the NOINDEX meta tag
+            $tmpl =~ s/<meta name="robots"[^>]*>//goi;
+        } else {
+            $text = "";
+        }
+        $tmpl =~ s/%REVTITLE%//go;
+    } elsif( $rev < $maxrev ) {
+        # disable edit of previous revisions - FIXME consider change
+        # to use two templates
+        # SMELL: won't work with non-default skins, see %EDITURL%
+        $tmpl =~ s/%EDITTOPIC%/<strike>Edit<\/strike>/go;
+        $tmpl =~ s/<a [^>]*?>Attach<\/a>/<strike>Attach<\/strike>/goi;
+        $tmpl =~ s|<a [^>]*?>Rename/move<\/a>|<strike>Rename/move<\/strike>|goi;
+        $tmpl =~ s/%REVTITLE%/\(r1.$rev\)/go;
+        $tmpl =~ s/%REVARG%/&rev=1.$rev/go;
+    } else {
+        # Remove the NOINDEX meta tag (for robots) from both Edit and 
+        # Create pages
+        $tmpl =~ s/<meta name="robots"[^>]*>//goi;
+        my $editAction = $topicExists ? 'Edit' : 'Create';
 
-  if( $TWiki::doLogTopicView ) {
-    # write log entry
-    &TWiki::Store::writeLog( "view", "$webName.$topic", $extra );
-  }
+        # Special case for 'view' to handle %EDITTOPIC% and Edit vs. Create.
+        # New %EDITURL% variable is implemented by handleCommonTags, suffixes
+        # '?t=NNNN' to ensure that every Edit link is unique, fixing
+        # Codev.RefreshEditPage bug relating to caching of Edit page.
+        $tmpl =~ s!%EDITTOPIC%!<a href=\"%EDITURL%\"><b>$editAction</b></a>!go;
 
-  my( $mirrorSiteName, $mirrorViewURL, $mirrorLink, $mirrorNote ) = &TWiki::readOnlyMirrorWeb( $webName );
-  if( $mirrorSiteName ) {
-    # disable edit and attach
-    # FIXME: won't work with non-default skins, see %EDITURL%
-    $tmpl =~ s/%EDITTOPIC%/$mirrorLink | <strike>Edit<\/strike>/go;
-    $tmpl =~ s/<a [^>]*?>Attach<\/a>/<strike>Attach<\/strike>/goi;
-    if( $topicExists ) {
-      # remove the NOINDEX meta tag
-      $tmpl =~ s/<meta name="robots"[^>]*>//goi;
-    } else {
-      $text = "";
+        # FIXME: Implement ColasNahaboo's suggested %EDITLINK% along the 
+        # same lines, within handleCommonTags
+        $tmpl =~ s/%REVTITLE%//go;
+        $tmpl =~ s/%REVARG%//go;
     }
-    $tmpl =~ s/%REVTITLE%//go;
-  } elsif( $rev < $maxrev ) {
-    # disable edit of previous revisions - FIXME consider change to use two templates
-    # FIXME: won't work with non-default skins, see %EDITURL%
-    $tmpl =~ s/%EDITTOPIC%/<strike>Edit<\/strike>/go;
-    $tmpl =~ s/<a [^>]*?>Attach<\/a>/<strike>Attach<\/strike>/goi;
-    $tmpl =~ s|<a [^>]*?>Rename/move<\/a>|<strike>Rename/move<\/strike>|goi;
-    $tmpl =~ s/%REVTITLE%/\(r1.$rev\)/go;
-    $tmpl =~ s/%REVARG%/&rev=1.$rev/go;
-  } else {
-    # Remove the NOINDEX meta tag (for robots) from both Edit and 
-    # Create pages
-    $tmpl =~ s/<meta name="robots"[^>]*>//goi;
-    my $editAction = $topicExists ? 'Edit' : 'Create';
 
-    # Special case for 'view' to handle %EDITTOPIC% and Edit vs. Create.
-    # New %EDITURL% variable is implemented by handleCommonTags, suffixes
-    # '?t=NNNN' to ensure that every Edit link is unique, fixing
-    # Codev.RefreshEditPage bug relating to caching of Edit page.
-    $tmpl =~ s!%EDITTOPIC%!<a href=\"%EDITURL%\"><b>$editAction</b></a>!go;
+    # SMELL: HUH? - TODO: why would you not show the revisions around
+    # the version that you are displaying? and this logic is yucky@!
+    my $i = $maxrev;
+    my $j = $maxrev;
+    my $revisions = "";
+    my $breakRev = 0;
+    if( ( $TWiki::numberOfRevisions > 0 ) &&
+        ( $TWiki::numberOfRevisions < $maxrev ) ) {
+        $breakRev = $maxrev - $TWiki::numberOfRevisions + 1;
+    }
+    while( $i > 0 ) {
+        if( $i == $rev) {
+            $revisions = "$revisions | r1.$i";
+        } else {
+            $revisions = "$revisions | <a href=\"%SCRIPTURLPATH%/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev=1.$i\">r1.$i</a>";
+        }
+        if( $i != 1 ) {
+            if( $i == $breakRev ) {
+                $i = 1;
+            } else {
+                $j = $i - 1;
+                $revisions = "$revisions | <a href=\"%SCRIPTURLPATH%/rdiff%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev1=1.$i&amp;rev2=1.$j\">&gt;</a>";
+            }
+        }
+        $i = $i - 1;
+    }
+    $tmpl =~ s/%REVISIONS%/$revisions/go;
 
-    # FIXME: Implement ColasNahaboo's suggested %EDITLINK% along the 
-    # same lines, within handleCommonTags
-    $tmpl =~ s/%REVTITLE%//go;
-    $tmpl =~ s/%REVARG%//go;
-  }
+    $tmpl =~ s/%REVINFO%/%REVINFO%$mirrorNote/go;
+    $tmpl = TWiki::handleCommonTags( $tmpl, $topic );
 
-#SMELL: HUH? - TODO: why would you not show the revisions around the version that you are displaying? and this logic is yucky@!
-  my $i = $maxrev;
-  my $j = $maxrev;
-  my $revisions = "";
-  my $breakRev = 0;
-  if( ( $TWiki::numberOfRevisions > 0 ) && ( $TWiki::numberOfRevisions < $maxrev ) ) {
-    $breakRev = $maxrev - $TWiki::numberOfRevisions + 1;
-  }
-  while( $i > 0 ) {
-    if( $i == $rev) {
-      $revisions = "$revisions | r1.$i";
+    if( $viewRaw ) {
+        $tmpl =~ s/%META{[^}]*}%//go;
     } else {
-      $revisions = "$revisions | <a href=\"%SCRIPTURLPATH%/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev=1.$i\">r1.$i</a>";
+        $tmpl = TWiki::Render::renderMetaTags( $webName, $topic, $tmpl, $meta, ( $rev == $maxrev ) );
     }
-    if( $i != 1 ) {
-      if( $i == $breakRev ) {
-        $i = 1;
-      } else {
-        $j = $i - 1;
-        $revisions = "$revisions | <a href=\"%SCRIPTURLPATH%/rdiff%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev1=1.$i&amp;rev2=1.$j\">&gt;</a>";
-      }
-    }
-    $i = $i - 1;
-  }
-  $tmpl =~ s/%REVISIONS%/$revisions/go;
+    $tmpl = TWiki::Render::getRenderedVersion( $tmpl, "", $meta ); ## better to use meta rendering?
 
-  $tmpl =~ s/%REVINFO%/%REVINFO%$mirrorNote/go;
+    $tmpl =~ s/%TEXT%/$text/go;
+    $tmpl =~ s/%MAXREV%/1.$maxrev/go;
+    $tmpl =~ s/%CURRREV%/1.$rev/go;
+    $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> tags (PTh 06 Nov 2000)
 
-  $tmpl = &TWiki::handleCommonTags( $tmpl, $topic );
-  if( $viewRaw ) {
-    $tmpl =~ s/%META{[^}]*}%//go;
-  } else {
-    $tmpl = &TWiki::handleMetaTags( $webName, $topic, $tmpl, $meta, ( $rev == $maxrev ) );
-  }
-  TWiki::UI::writeDebugTimes( "view - handleCommonTags for template done" );
-  $tmpl = &TWiki::Render::getRenderedVersion( $tmpl, "", $meta ); ## better to use meta rendering?
-  $tmpl =~ s/%TEXT%/$text/go;
-  $tmpl =~ s/%MAXREV%/1.$maxrev/go;
-  $tmpl =~ s/%CURRREV%/1.$rev/go;
-  $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> tags (PTh 06 Nov 2000)
+    # check access permission
+    my $viewAccessOK = TWiki::Access::checkAccessPermission( "view", $wikiUserName, $text, $topic, $webName );
 
-  # check access permission
-  my $viewAccessOK = &TWiki::Access::checkAccessPermission( "view", $wikiUserName, $text, $topic, $webName );
-
-  if( (!$topicExists) || $TWiki::readTopicPermissionFailed ) {
-    # Can't read requested topic and/or included (or other accessed topics
-    # user could not be authenticated, may be not logged in yet?
-    my $viewauthFile = $ENV{'SCRIPT_FILENAME'};
-    $viewauthFile =~ s|/view|/viewauth|o;
-    if( ( ! $query->remote_user() ) && (-e $viewauthFile ) ) {
-      # try again with authenticated viewauth script
-      # instead of non authenticated view script
-      my $url = $ENV{"REQUEST_URI"};
-      if( $url && $url =~ m|/view| ) {
-        # $url i.e. is "twiki/bin/view.cgi/Web/Topic?cms1=val1&cmd2=val2"
-        $url =~ s|/view|/viewauth|o;
-        $url = "$TWiki::urlHost$url";
-      } else {
-       # If REQUEST_URI is rewritten and does not contain the name "view"
-        # try looking at the CGI environment variable SCRIPT_NAME.
-        #
-        # Assemble the new URL using the host, the changed script name,
-        # the path info, and the query string.  All three query variables
-        # are in the list of the canonical request meta variables in CGI 1.1.
-        my $script      = $ENV{'SCRIPT_NAME'};
-        my $pathInfo    = $ENV{'PATH_INFO'};
-        my $queryString = $ENV{'QUERY_STRING'};
-        $pathInfo    = '/' . $pathInfo    if ($pathInfo);
-        $queryString = '?' . $queryString if ($queryString);
-        if ($script && $script =~ m|/view| ) {
-          $script =~ s|/view|/viewauth|o;
-          $url = "$TWiki::urlHost$script$pathInfo$queryString";
-        } else {
-          # If SCRIPT_NAME does not contain the name "view"
-          # the last hope is to try the SCRIPT_FILENAME ...
-          $viewauthFile =~ s|^.*/viewauth|/viewauth|o;  # strip off $Twiki::scriptUrlPath
-         $url = "$TWiki::urlHost$TWiki::scriptUrlPath/$viewauthFile$pathInfo$queryString";
-         }
-      }
-      TWiki::UI::redirect( $url );
+    # SMELL: why calculate viewAccessOK and then use readTopicPermissionFailed
+    # SMELL: readTopicPermissionFailed break TWiki encapsulation
+    if( (!$topicExists) || $TWiki::readTopicPermissionFailed ) {
+        # Can't read requested topic and/or included (or other accessed topics
+        # user could not be authenticated, may be not logged in yet?
+        my $viewauthFile = $ENV{'SCRIPT_FILENAME'};
+        # SMELL: depends on view script being called view. And what if this
+        # script is _already_ viewauth? Could use \b, but still depends on
+        # the name.
+        $viewauthFile =~ s|/view|/viewauth|o;
+        if( ( ! $query->remote_user() ) && (-e $viewauthFile ) ) {
+            # try again with authenticated viewauth script
+            # instead of non authenticated view script
+            my $url = $ENV{"REQUEST_URI"};
+            if( $url && $url =~ m|/view| ) {
+                # $url i.e. is "twiki/bin/view.cgi/Web/Topic?cms1=val1&cmd2=val2"
+                $url =~ s|/view|/viewauth|o;
+                $url = "$TWiki::urlHost$url";
+            } else {
+                # If REQUEST_URI is rewritten and does not contain the name "view"
+                # try looking at the CGI environment variable SCRIPT_NAME.
+                #
+                # Assemble the new URL using the host, the changed script name,
+                # the path info, and the query string.  All three query variables
+                # are in the list of the canonical request meta variables in CGI 1.1.
+                my $script      = $ENV{'SCRIPT_NAME'};
+                my $pathInfo    = $ENV{'PATH_INFO'};
+                my $queryString = $ENV{'QUERY_STRING'};
+                $pathInfo    = '/' . $pathInfo    if ($pathInfo);
+                $queryString = '?' . $queryString if ($queryString);
+                if ($script && $script =~ m|/view| ) {
+                    $script =~ s|/view|/viewauth|o;
+                    $url = "$TWiki::urlHost$script$pathInfo$queryString";
+                } else {
+                    # If SCRIPT_NAME does not contain the name "view"
+                    # the last hope is to try the SCRIPT_FILENAME ...
+                    $viewauthFile =~ s|^.*/viewauth|/viewauth|o;  # strip off $Twiki::scriptUrlPath
+                    $url = "$TWiki::urlHost$TWiki::scriptUrlPath/$viewauthFile$pathInfo$queryString";
+                }
+            }
+            TWiki::UI::redirect( $url );
+        }
     }
-  }
-  if( ! $viewAccessOK ) {
-    TWiki::UI::oops( $webName, $topic, "accessview" );
-  }
+    if( ! $viewAccessOK ) {
+        TWiki::UI::oops( $webName, $topic, "accessview" );
+    }
 
-  TWiki::UI::writeDebugTimes( "view - checked access permissions" );
-
-  # Write header based on "contenttype" parameter, used to produce
-  # MIME types like text/plain or text/xml, e.g. for RSS feeds.
-  if( $contentType ) {
-    TWiki::writeHeaderFull( $query, 'basic', $contentType, 0);
-    if( $skin =~ /^rss/ ) {
-      $tmpl =~ s/<img [^>]*>//g;  # remove image tags
-      $tmpl =~ s/<a [^>]*>//g;    # remove anchor tags
-      $tmpl =~ s/<\/a>//g;        # remove anchor tags
+    # Write header based on "contenttype" parameter, used to produce
+    # MIME types like text/plain or text/xml, e.g. for RSS feeds.
+    if( $contentType ) {
+        if( $skin =~ /^rss/ ) {
+            $tmpl =~ s/<img [^>]*>//g;  # remove image tags
+            $tmpl =~ s/<a [^>]*>//g;    # remove anchor tags
+            $tmpl =~ s/<\/a>//g;        # remove anchor tags
+        }
+    } elsif( $skin =~ /^rss/ ) {
+        $tmpl =~ s/<img [^>]*>//g;  # remove image tags
+        $tmpl =~ s/<a [^>]*>//g;    # remove anchor tags
+        $tmpl =~ s/<\/a>//g;        # remove anchor tags
+        $contentType = 'text/xml';
+    } else {
+        $contentType = 'text/html'
     }
-  } elsif( $skin =~ /^rss/ ) {
-    TWiki::writeHeaderFull( $query, 'basic', 'text/xml', 0);
-    $tmpl =~ s/<img [^>]*>//g;  # remove image tags
-    $tmpl =~ s/<a [^>]*>//g;    # remove anchor tags
-    $tmpl =~ s/<\/a>//g;        # remove anchor tags
-  } else {
-    TWiki::writeHeader( $query );
-  }
 
-  # print page content
-  print $tmpl;
-
-  TWiki::UI::writeDebugTimes( "view - done" );
+    TWiki::writeHeaderFull( $query, 'basic', $contentType, length( $tmpl ));
+    print $tmpl;
 }
 
 1;
Index: lib/TWiki/UI/Save.pm
===================================================================
--- lib/TWiki/UI/Save.pm	(revision 1767)
+++ lib/TWiki/UI/Save.pm	(working copy)
@@ -52,7 +52,7 @@
 sub save {
   my( $webName, $topic, $userName, $query ) = @_;
   if ( _save( @_ )) {
-    TWiki::redirect( $query, TWiki::getViewUrl( TWiki::Store::normalizeWebTopicName($webName, $topic)) );
+    TWiki::redirect( $query, TWiki::getViewUrl( TWiki::normalizeWebTopicName($webName, $topic)) );
   }
 }
 
@@ -82,10 +82,10 @@
 
   my $topicExists  = TWiki::Store::topicExists( $webName, $topic );
 
+  return 0 if TWiki::UI::isMirror( $webName, $topic );
+
   return 0 unless TWiki::UI::webExists( $webName, $topic );
 
-  return 0 if TWiki::UI::isMirror( $webName, $topic );
-
   # Prevent saving existing topic?
   if( $onlyNewTopic && $topicExists ) {
     # Topic exists and user requested oops if it exists
@@ -96,13 +96,13 @@
   # prevent non-Wiki names?
   if( ( $onlyWikiName )
       && ( ! $topicExists )
-      && ( ! ( &TWiki::isWikiName( $topic ) || &TWiki::isAbbrev( $topic ) ) ) ) {
+      && ( ! TWiki::isValidTopicName( $topic ) ) ) {
     # do not allow non-wikinames, redirect to view topic
     TWiki::UI::redirect( TWiki::getViewUrl( $webName, $topic ) );
     return 0;
   }
 
-  my $wikiUserName = TWiki::userToWikiName( $userName );
+  my $wikiUserName = TWiki::User::userToWikiName( $userName );
   return 0 unless TWiki::UI::isAccessPermitted( $webName, $topic,
                                             "change", $wikiUserName );
 
@@ -185,7 +185,7 @@
 sub savemulti {
   my( $webName, $topic, $userName, $query ) = @_;
 
-  my $redirecturl = TWiki::getViewUrl( TWiki::Store::normalizeWebTopicName($webName, $topic));
+  my $redirecturl = TWiki::getViewUrl( TWiki::normalizeWebTopicName($webName, $topic));
 
   my $saveaction = lc($query->param( 'action' ));
   if ( $saveaction eq "checkpoint" ) {
Index: lib/TWiki/UI/Oops.pm
===================================================================
--- lib/TWiki/UI/Oops.pm	(revision 1767)
+++ lib/TWiki/UI/Oops.pm	(working copy)
@@ -42,33 +42,32 @@
   my ( $web, $topic, $user, $query ) = @_;
 
   my $tmplName = $query->param( 'template' ) || "oops";
-  my $skin = $query->param( "skin" ) || TWiki::Prefs::getPreferencesValue( "SKIN" );
-  my $tmplData = TWiki::Store::readTemplate( $tmplName, $skin );
+  my $skin = TWiki::getSkin();
+
+  my $tmplData = TWiki::Templates::readTemplate( $tmplName, $skin );
   if( ! $tmplData ) {
-    TWiki::writeHeader( $query );
-    print "<html><body>\n"
-      . "<h1>TWiki Installation Error</h1>\n"
-        . "Template file $tmplName.tmpl not found or template directory \n"
-          . "$TWiki::templateDir not found.<p />\n"
-            . "Check the \$templateDir variable in TWiki.cfg.\n"
-              . "</body></html>\n";
-    return;
+      $tmplData = "<html><body>\n"
+        . "<h1>TWiki Installation Error</h1>\n"
+          . "Template file $tmplName.tmpl not found or template directory \n"
+            . "$TWiki::templateDir not found.<p />\n"
+              . "Check the \$templateDir variable in TWiki.cfg.\n"
+                . "</body></html>\n";
+  } else {
+      my $param = $query->param( 'param1' ) || "";
+      $tmplData =~ s/%PARAM1%/$param/go;
+      $param = $query->param( 'param2' ) || "";
+      $tmplData =~ s/%PARAM2%/$param/go;
+      $param = $query->param( 'param3' ) || "";
+      $tmplData =~ s/%PARAM3%/$param/go;
+      $param = $query->param( 'param4' ) || "";
+      $tmplData =~ s/%PARAM4%/$param/go;
+
+      $tmplData = TWiki::handleCommonTags( $tmplData, $topic );
+      $tmplData = TWiki::Render::getRenderedVersion( $tmplData );
+      $tmplData =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
   }
 
-  my $param = $query->param( 'param1' ) || "";
-  $tmplData =~ s/%PARAM1%/$param/go;
-  $param = $query->param( 'param2' ) || "";
-  $tmplData =~ s/%PARAM2%/$param/go;
-  $param = $query->param( 'param3' ) || "";
-  $tmplData =~ s/%PARAM3%/$param/go;
-  $param = $query->param( 'param4' ) || "";
-  $tmplData =~ s/%PARAM4%/$param/go;
-
-  $tmplData = &TWiki::handleCommonTags( $tmplData, $topic );
-  $tmplData = &TWiki::Render::getRenderedVersion( $tmplData );
-  $tmplData =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-
-  TWiki::writeHeader( $query );
+  TWiki::writeHeader( $query, length( $tmplData ));
   print $tmplData;
 }
 
Index: lib/TWiki/UI/Preview.pm
===================================================================
--- lib/TWiki/UI/Preview.pm	(revision 1767)
+++ lib/TWiki/UI/Preview.pm	(working copy)
@@ -18,11 +18,12 @@
 use strict;
 use TWiki;
 use TWiki::UI;
+use TWiki::Templates;
 
 sub preview {
   my ( $webName, $topic, $userName, $query ) = @_;
 
-  my $skin = $query->param( "skin" );
+  my $skin = TWiki::getSkin();
   my $changeform = $query->param( 'submitChangeForm' ) || "";
   my $dontNotify = $query->param( "dontnotify" ) || "";
   my $saveCmd = $query->param( "cmd" ) || "";
@@ -37,15 +38,13 @@
   my $ptext = "";
   my $meta = "";
   my $formFields = "";
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
+  my $wikiUserName = TWiki::User::userToWikiName( $userName );
   
   return if TWiki::UI::isMirror( $webName, $topic );
 
   # reset lock time, this is to prevent contention in case of a long edit session
-  &TWiki::Store::lockTopic( $topic );
+  TWiki::Store::lockTopic( $webName, $topic );
 
-  $skin = &TWiki::Prefs::getPreferencesValue( "SKIN" ) unless( $skin );
-  
   # Is user looking to change the form used?  Sits oddly in preview, but 
   # to avoid Javascript and pick up text on edit page it has to be in preview.
   if( $changeform ) {
@@ -54,7 +53,7 @@
   }
 
   # get view template, standard view or a view with a different skin
-  $tmpl = &TWiki::Store::readTemplate( "preview", $skin );
+  $tmpl = &TWiki::Templates::readTemplate( "preview", $skin );
   $tmpl =~ s/%DONTNOTIFY%/$dontNotify/go;
   if( $saveCmd ) {
     return unless TWiki::UI::userIsAdmin( $webName, $topic, $wikiUserName );
@@ -105,7 +104,7 @@
   }
 
   my @verbatim = ();
-  $ptext = &TWiki::takeOutVerbatim( $ptext, \@verbatim );
+  $ptext = TWiki::Render::takeOutBlocks( $ptext, "verbatim", \@verbatim );
   $ptext =~ s/ {3}/\t/go;
   $ptext = &TWiki::Prefs::updateSetFromForm( $meta, $ptext );
   $ptext = &TWiki::handleCommonTags( $ptext, $topic );
@@ -118,10 +117,12 @@
   $ptext =~ s@<form(?:|\s.*?)>@<form action="$oopsUrl">\n<input type="hidden" name="template" value="oopspreview">@goi;
   $ptext =~ s@(?<=<)([^\s]+?[^>]*)(onclick=(?:"location.href='.*?'"|location.href='[^']*?'(?=[\s>])))@$1onclick="location.href='$oopsUrl\?template=oopspreview'"@goi;
 
-  $ptext = &TWiki::putBackVerbatim( $ptext, "pre", @verbatim );
+  $ptext = TWiki::Render::putBackBlocks( $ptext, \@verbatim,
+                                         "verbatim", "pre",
+                                         \&TWiki::Render::verbatimCallBack );
 
   $tmpl = &TWiki::handleCommonTags( $tmpl, $topic );
-  $tmpl = &TWiki::handleMetaTags( $webName, $topic, $tmpl, $meta );
+  $tmpl = TWiki::Render::renderMetaTags( $webName, $topic, $tmpl, $meta, 0 );
   $tmpl = &TWiki::Render::getRenderedVersion( $tmpl );
   $tmpl =~ s/%TEXT%/$ptext/go;
 
@@ -131,7 +132,7 @@
   $tmpl =~ s/%FORMFIELDS%/$formFields/go;
   $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
 
-  &TWiki::writeHeader( $query );
+  TWiki::writeHeader( $query, length( $tmpl ));
   print $tmpl;
 }
 
